set echo on feedback on timing on
spool proftest1

drop table proftest_table;

create table proftest_table
(
	c1	number,
	c2	number,
	c3	number,
	c4	number
);

begin
	for i in 1..100000 loop
		insert into proftest_table values (i, 100000-i, i, 100000-i);
	end loop;
end;
/

commit;

create or replace procedure proftest1(in_mode in varchar2)
is
	--
	cursor get_numbers is
	select		trim(to_char(c1)) c1
	from		proftest_table
	where		c1 between 10000 and 12999;
	--
	v_str		varchar2(32760) := '';
	v_str2		varchar2(100) := '';
	x		integer;
	y		integer;
	v_cnt		integer := 1;
	--
begin
	--
	dbms_profiler.start_profiler(in_mode || ': proftest1');
	--
	for x in get_numbers loop
		--
		if get_numbers%rowcount = 1 then
			v_str := x.c1;
		else
			v_str := v_str || ',' || x.c1;
		end if;
		--
		v_cnt := v_cnt + 1;
		--
	end loop; /* end of "get_numbers" cursor loop */
	--
	x := 1;
	for i in 1..100 loop
		--
		for j in 1..v_cnt loop
			--
			if in_mode = 'Test #1' then
				y := instr(v_str, ',', 1, j);
			elsif in_mode = 'Test #2' then
				y := instr(v_str, ',', x, 1);
			else
				raise_application_error(-20000,
					'Invalid IN_MODE value');
			end if;
			--
			v_str2 := substr(v_str, x, (y -x));
			--
			dbms_output.put_line(j || ': "' || v_str2 || '"');
			--
			x := y + 1;
			--
		end loop;
		--
	end loop;
	--
	dbms_profiler.stop_profiler;
	--
end proftest1;
/

show errors

spool off
